routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('main');
});

Route::get('/member/login', [ MemberController::class, 'login' ] );

Route::get('/member/register', [ MemberController::class, 'register' ] );

Route::get('/member', [ MemberController::class, 'index' ]);

Route::get('/member/profile', [ MemberController::class, 'profile' ]);

Route::get('/dashboard', [ 
	MemberController::class,
	'index'])
	->name('dashbaord')
	->middleware(['auth']);


Route::middleware(['auth', 'can:is-admin'])->group(function(){

	Route::resource('admin/user', UserController::class);
	Route::resource('admin/role', RoleController::class);
	Route::resource('admin/plan', PlanController::class);
	
});

Route::get('/signup', [ SignUpController::class, 'index' ]);
Route::get('/signup/review/{id}', [ SignUpController::class, 'review' ]);
Route::post('/signup/go/{payment_gateway}', [ SignUpController::class, 'go' ])->name('signup.go');

Route::post('/signup/thankyou/{payment_gateway}', [ SignUpController::class, 'thankyou' ])->name('signup.thankyou');
Route::get('/signup/thankyou/{payment_gateway}', [ SignUpController::class, 'thankyou' ]);

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var string[]
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
<<<<<<< HEAD

    public function roles() {
        return $this->belongsToMany( Role::class);
    }

    public function setPasswordAttribute($value) {

        return $this->password = Hash::make($value);

    }

    
=======
>>>>>>> 423bcfc611f3ec3d81fcc816e69ee2d52a875bb9
}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use App\Models\Role;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Gate;
use Illuminate\Support\Facades\Hash;

class UserController extends Controller
{

    public function __construct() {
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $users = User::paginate(20);

        return view('admin.user.index', [ 'users' => $users ]);

    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.user.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        // echo  'Simpan pengguna baru';

        $form_data = $request->validate([
            'name' => 'required|min:5|max:255',
            'email' => 'required|email',
            'password' => 'required|confirmed'
        ]);

        $form_data['password'] = Hash::make( $form_data['password'] );

        $user = User::create($form_data);

        return redirect('admin/user')->with('success', "Pengguna {$user->name} ($user->id) telah ditambah");

    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {

        $user = User::find($id);
        $roles = Role::all();
        // dd($user);

        return view('admin.user.edit', [ 'user' => $user, 'roles' => $roles ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $user = User::findOrFail($id);

        $form_data = $request->validate([
            'name' => 'required|min:5|max:255',
            'email' => 'required|email'
        ]);

        $user->name = $form_data['name'];
        $user->email = $form_data['email'];

        $user->save();

        $user->roles()->sync( $request->roles );

        return redirect('admin/user')->with('success', "Pengguna {$user->name} ($id) telah dikemaskini");
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/admin/user/create.blade.php
@extends('layout.private') 


@section('content')

    <h1 class="h3 mb-3 text-gray-800">Tambah Pengguna Baru</h1>

    <div class="card shadow mb-4">
    <div class="card-header py-3">
        <h6 class="m-0 font-weight-bold text-primary">Isikan maklumat pengguna baru</h6>
    </div>
    <div class="card-body">

        <form action="{{ route('user.store') }}" method="post">
            @csrf

            <div class="mb-3 row">
                <label class="col-sm-2 col-form-label">Nama</label>
                <div class="col-sm-10">
                    <input type="text" class="form-control @error('name') is-invalid @enderror" name="name" value="{{ old( 'name' ) }}">
                    @error('name')
                    <div class="invalid-feedback">{{$message}}</div>
                    @enderror
                </div>
            </div>

            <div class="mb-3 row">
                <label class="col-sm-2 col-form-label">Email</label>
                <div class="col-sm-10">
                    <input type="text" class="form-control @error('email') is-invalid @enderror" name="email" value="{{ old( 'email' ) }}">
                    @error('email')
                    <div class="invalid-feedback">{{$message}}</div>
                    @enderror

                </div>
            </div>


            <div class="mb-3 row">
                <label class="col-sm-2 col-form-label">Password</label>
                <div class="col-sm-10">
                    <input type="password" class="form-control @error('password') is-invalid @enderror" name="password" value="">
                    @error('password')
                    <div class="invalid-feedback">{{$message}}</div>
                    @enderror

                </div>
            </div>

            <div class="mb-3 row">
                <label class="col-sm-2 col-form-label">Sahkan Password</label>
                <div class="col-sm-10">
                    <input type="password" class="form-control @error('password_confirmation') is-invalid @enderror" name="password_confirmation" value="">
                    @error('password_confirmation')
                    <div class="invalid-feedback">{{$message}}</div>
                    @enderror

                </div>
            </div>

            <a href="/admin/user" class="btn btn-secondary btn-lg">Batal</a>

            <button class="btn btn-lg btn-primary">Simpan</button>

        </form>

    </div>
</div>

@endsection 

resources/views/admin/user/edit.blade.php
@extends('layout.private')


@section('content')

<h1 class="h3 mb-3 text-gray-800">Edit Pengguna</h1>

<div class="card shadow mb-4">
    <div class="card-header py-3">
        <h6 class="m-0 font-weight-bold text-primary">{{ $user->name }}</h6>
    </div>
    <div class="card-body">

        <form action="{{ route('user.update', $user->id) }}" method="post">
            @csrf
            @method('put')

            <div class="mb-3 row">
                <label class="col-sm-2 col-form-label">Nama</label>
                <div class="col-sm-10">
                    <input type="text" class="form-control @error('name') is-invalid @enderror" name="name" value="{{ old( 'name', $user->name ) }}">
                    @error('name')
                    <div class="invalid-feedback">{{$message}}</div>
                    @enderror
                </div>
            </div>

            <div class="mb-3 row">
                <label class="col-sm-2 col-form-label">Email</label>
                <div class="col-sm-10">
                    <input type="text" class="form-control @error('email') is-invalid @enderror" name="email" value="{{ old( 'email', $user->email ) }}">
                    @error('email')
                    <div class="invalid-feedback">{{$message}}</div>
                    @enderror

                </div>
            </div>

            <div class="mb-3 row">
                <label class="col-sm-2 col-form-label">Peranan</label>
                <div class="col-sm-10">
                    @foreach($roles as $role)

                    <div class="custom-control custom-checkbox small">
                        <input  
                            @if( in_array($role->id, $user->roles->pluck('id')->toArray() ))
                                checked
                            @endif
                        type="checkbox" class="custom-control-input" 
                        name="roles[]" value="{{$role->id}}" id="role_{{$role->id}}">
                        <label class="custom-control-label" for="role_{{$role->id}}">{{$role->name}}</label>
                    </div>
                    @endforeach
                </div>
            </div>

            <button class="btn btn-lg btn-primary">Simpan</button>

        </form>

    </div>
</div>


@endsection

resources/views/admin/user/index.blade.php
@extends('layout.private')


@section('content')
<div class="d-flex justify-content-between mb-3">
    <h1 class="h3 mb-2 text-gray-800">Senarai Pengguna</h1>

    <a href="/admin/user/create" class="btn btn-secondary">Tambah Pengguna</a>
</div>


@if( session('success') ) 
    <div class="alert alert-success">{{ session('success') }}</div>
@endif

<div class="card shadow mb-4">
    <div class="card-header py-3">
        <h6 class="m-0 font-weight-bold text-primary">DataTables Example</h6>
    </div>
    <div class="card-body">
        <div class="table-responsive">
        {{ $users->links() }}

            <table class="table">
                <thead>
                    <tr>
                        <th>ID</th>
                        <th>NAMA</th>
                        <th>EMAIL</th>
                        <th></th>
                    </tr>
                </thead>

                <tbody>
                    @foreach($users as $user)
                    <tr>
                        <td>{{ $user->id }}</td>
                        <td>{{ $user->name }}</td>
                        <td>{{ $user->email }}</td>
                        <td>
                            <a href="#" class="btn btn-sm btn-danger">DELETE</a>
                            <a href="{{ route('user.edit', $user->id) }}" class="btn btn-sm btn-primary">EDIT</a>
                        </td>
                    </tr>
                    @endforeach
                </tbody>
            </table>

            {{ $users->links() }}

        </div>
    </div>
</div>

@endsection